import sys
import services
import inspect
import sims
import sims.sim_info
from tag import Tag

import MATY

badtags = [Tag.Func_Computer, Tag.Func_Bookcase, Tag.Func_Cooking]
goodtags = [Tag.Func_Bed, Tag.Func_Couch, Tag.Func_LivingChair, Tag.Func_DiningChair, Tag.Func_Ottoman, Tag.Func_Stool]

def log(text): MATY.log(text, "preload.txt")

from autonomy.autonomy_request import PrerollAutonomyRequest
def objects_to_score(original, self, *args, **kwargs):
    sim = self.sim
    result = None
    is_active_lot = services.active_household() == services.owning_household_of_active_lot()
    #log('generating preroll autonomy for {} {} {} {}'.format(sim.first_name, sim.last_name, is_active_lot, sim.is_on_active_lot()))
    if sim is not None and sim.sim_info is not None:
        if not sim.sim_info.is_selectable and (not is_active_lot or not sim.is_on_active_lot()):
            for obj in original(self, *args, **kwargs):
                #log('   testing {}'.format(obj))
                if not obj.has_any_tag(badtags):
                    #log('   returning {}'.format(obj))
                    yield obj
                pass
            pass
        elif sim.is_outside or not sim.is_on_active_lot():
            for obj in original(self, *args, **kwargs):
                #log('   outside testing {}'.format(obj))
                if obj.has_any_tag(goodtags) and not obj.has_any_tag(badtags):
                    #log('   outside returning {}'.format(obj))
                    yield obj
                pass
            pass
        pass
    pass

import sims4.commands
@sims4.commands.Command('nostupidpreloadactions',command_type=sims4.commands.CommandType.Live)
def InstallationCheck(*args, _connection=None):
    output=sims4.commands.CheatOutput(_connection)
    if MATY.IntegrityCheck():
        output('NoStupidPreloadActions seems to be installed correctly.')
    else:
        output('MATYlib is missing or outdated: redownload, reinstall.')
    return
